#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <netinet/in.h>
#include <pthread.h>
#include <termios.h>
#include <math.h>
#include <netdb.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <zlib.h>

#include "rtl-sdr.h"

#pragma pack (1)


#pragma comment(lib, "ws2_32.lib")

#include "mode_s.c"




int CompressOn = 0;
int BinarComOn = 0;
char NamePrmADSB[256]={"URRR2"};
double LOC_B2=(47*3600)+(11*60)+53.52;
double LOC_L2=(39*3600)+(37*60)+41.52;



int PrintVisual = 1;



typedef int DWORD; 



int CIKL = 1;

pthread_mutex_t hSemaFILE;


int ServerRadio = 2;
int  statusInt[3] = {0,0,0}; 
u_short CLI_PORT       [3] = {8888,8888,8888};
char    addr_IP        [3][64]={{"188.168.58.111"},{"188.168.58.111"},{"188.168.58.111"}}; 
int     cli_socket     [3] = {-1,-1,-1};
char    statusTcpClient[3][256]={{""},{""},{""}};
int SendInfaOutTcp(int sid,char *prm, int LEN);

#define DEFAULT_BUF_LENGTH (16 * 16384)

int OutOriginalDateOn = 0;
int OnVievTimeCorrect = 0;
int sssStartTimer=0;
unsigned long GlobDel = 2000000; 
int ukSave = 0;
int ukLoad = 0;
unsigned char RAW_SDR[100][DEFAULT_BUF_LENGTH];
int   RAW_SDRcnt[100];



int  KogDa = 50;
int  TicSecCompress = 0;
char bufCompress[0xFFFF];
int  ukCompress = 0;
unsigned long destLen = 0xFFFF;
unsigned char dest[0xFFFF];  




/* this variable holds the number next to the API on the screen that */ /* the user clicks on */ enum cAPIs { ALLOC = 1, CREATE, FILLATT, FILLCHAR, FLUSH, FREE,   GENCTRL, GETCP, GETOUTCP, GETCUR, GETMODE, GETCONINFO, GETTITLE,   GETLARGEST, GETNUMEV, GETNUMBUT, PEEK, READCONIN, READCONOUT,   READCONATT, READCONCHAR, SCROLL, SETACTIVE, SETCP, SETOUTCP,   SETCURINF, SETCURPOS, SETMODE, SETSIZE, SETATT, SETTITLE, SETINFO,   SETHAND, WRITEIN, WRITEOUT, WRITEATT, WRITECHAR };  
#define MADSB_MODE_ALL           0x02 /* send all demodulated squitters, in *...; format */
#define MADSB_MODE_ADSB          0x03 /* send only ADS-B (DF=17/18/19) squitters, in *...; format */
#define MADSB_MODE_ADSB_CRC      0x04 /* send only ADS-B squitters with CRC */
#define MADSB_MODE_TIMECODE      0x10
#define MADSB_MODE_FRAMENUMBER   0x20


//void ComPortWrite(unsigned char *buf,DWORD kol);


typedef struct {
	int source_id;
	char data[16];
	char avr_data[42];
	unsigned int avr_data_len;
	unsigned int timestamp;
	double lat;
	double lon;
} adsb_data; 



void *adsb_f(void *pr);



//
// ============================= Utility functions ==========================
//
static uint64_t mstime(void) {
    struct timeval tv;
    uint64_t mst;

    gettimeofday(&tv, NULL);
    mst = ((uint64_t)tv.tv_sec)*1000;
    mst += tv.tv_usec/1000;
    return mst;
}


//
//=========================================================================
//
// We have received a Mode A or C response. 
//
// Search through the list of known Mode-S aircraft and tag them if this Mode A/C 
// matches their known Mode S Squawks or Altitudes(+/- 50feet).
//
// A Mode S equipped aircraft may also respond to Mode A and Mode C SSR interrogations.
// We can't tell if this is a Mode A or C, so scan through the entire aircraft list
// looking for matches on Mode A (squawk) and Mode C (altitude). Flag in the Mode S
// records that we have had a potential Mode A or Mode C response from this aircraft. 
//
// If an aircraft responds to Mode A then it's highly likely to be responding to mode C 
// too, and vice verca. Therefore, once the mode S record is tagged with both a Mode A
// and a Mode C flag, we can be fairly confident that this Mode A/C frame relates to that
// Mode S aircraft.
//
// Mode C's are more likely to clash than Mode A's; There could be several aircraft 
// cruising at FL370, but it's less likely (though not impossible) that there are two 
// aircraft on the same squawk. Therefore, give precidence to Mode A record matches
//
// Note : It's theoretically possible for an aircraft to have the same value for Mode A 
// and Mode C. Therefore we have to check BOTH A AND C for EVERY S.
//  
void interactiveUpdateAircraftModeA(struct aircraft *a) {
    struct aircraft *b = Modes.aircrafts;

    while(b) {
        if ((b->modeACflags & MODEAC_MSG_FLAG) == 0) {// skip any fudged ICAO records 

            // If both (a) and (b) have valid squawks...
            if ((a->bFlags & b->bFlags) & MODES_ACFLAGS_SQUAWK_VALID) {
                // ...check for Mode-A == Mode-S Squawk matches
                if (a->modeA == b->modeA) { // If a 'real' Mode-S ICAO exists using this Mode-A Squawk
                    b->modeAcount   = a->messages;
                    b->modeACflags |= MODEAC_MSG_MODEA_HIT;
                    a->modeACflags |= MODEAC_MSG_MODEA_HIT;
                    if ( (b->modeAcount > 0) && 
                       ( (b->modeCcount > 1) 
                      || (a->modeACflags & MODEAC_MSG_MODEA_ONLY)) ) // Allow Mode-A only matches if this Mode-A is invalid Mode-C
                        {a->modeACflags |= MODEAC_MSG_MODES_HIT;}    // flag this ModeA/C probably belongs to a known Mode S                    
                }
            } 

            // If both (a) and (b) have valid altitudes...
            if ((a->bFlags & b->bFlags) & MODES_ACFLAGS_ALTITUDE_VALID) {
                // ... check for Mode-C == Mode-S Altitude matches
                if (  (a->modeC     == b->modeC    )     // If a 'real' Mode-S ICAO exists at this Mode-C Altitude
                   || (a->modeC     == b->modeC + 1)     //          or this Mode-C - 100 ft
                   || (a->modeC + 1 == b->modeC    ) ) { //          or this Mode-C + 100 ft
                    b->modeCcount   = a->messages;
                    b->modeACflags |= MODEAC_MSG_MODEC_HIT;
                    a->modeACflags |= MODEAC_MSG_MODEC_HIT;
                    if ( (b->modeAcount > 0) && 
                         (b->modeCcount > 1) )
                        {a->modeACflags |= (MODEAC_MSG_MODES_HIT | MODEAC_MSG_MODEC_OLD);} // flag this ModeA/C probably belongs to a known Mode S                    
                }
            }
        }
        b = b->next;
    }
}


//
//=========================================================================
//
void interactiveUpdateAircraftModeS() {
    struct aircraft *a = Modes.aircrafts;

    while(a) {
        int flags = a->modeACflags;
        if (flags & MODEAC_MSG_FLAG) { // find any fudged ICAO records 

            // clear the current A,C and S hit bits ready for this attempt
            a->modeACflags = flags & ~(MODEAC_MSG_MODEA_HIT | MODEAC_MSG_MODEC_HIT | MODEAC_MSG_MODES_HIT);

            interactiveUpdateAircraftModeA(a);  // and attempt to match them with Mode-S
        }
        a = a->next;
    }
}


//
//=========================================================================
//
// Show the currently captured interactive data on screen.
//
void interactiveShowData(void) {
    struct aircraft *a = Modes.aircrafts;
    time_t now = time(NULL);
    int count = 0;
    char progress;
    char spinner[4] = "|/-\\";

    // Refresh screen every (MODES_INTERACTIVE_REFRESH_TIME) miliseconde
    if ((mstime() - Modes.interactive_last_update) < MODES_INTERACTIVE_REFRESH_TIME)
       {return;}

    Modes.interactive_last_update = mstime();    

    // Attempt to reconsile any ModeA/C with known Mode-S
    // We can't condition on Modes.modeac because ModeA/C could be comming 
    // in from a raw input port which we can't turn off.
    interactiveUpdateAircraftModeS();

    progress = spinner[time(NULL)%4];

#ifndef _WIN32
    printf("\x1b[H\x1b[2J");    // Clear the screen
#else
    cls();
#endif

    if (Modes.interactive_rtl1090 == 0) {
        printf (
"Hex     Mode  Sqwk  Flight   Alt    Spd  Hdg    Lat      Long   Sig  Msgs   Ti%c\n", progress);
    } else {
        printf (
"Hex    Flight   Alt      V/S GS  TT  SSR  G*456^ Msgs    Seen %c\n", progress);
    }
    printf(
"-------------------------------------------------------------------------------\n");

    while(a && (count < Modes.interactive_rows)) {

        if ((now - a->seen) < Modes.interactive_display_ttl)
            {
            int msgs  = a->messages;
            int flags = a->modeACflags;

            if ( (((flags & (MODEAC_MSG_FLAG                             )) == 0                    )                 )
              || (((flags & (MODEAC_MSG_MODES_HIT | MODEAC_MSG_MODEA_ONLY)) == MODEAC_MSG_MODEA_ONLY) && (msgs > 4  ) ) 
              || (((flags & (MODEAC_MSG_MODES_HIT | MODEAC_MSG_MODEC_OLD )) == 0                    ) && (msgs > 127) ) 
              ) {
                int altitude = a->altitude, speed = a->speed;
                char strSquawk[5] = " ";
                char strFl[6]     = " ";
                char strTt[5]     = " ";
                char strGs[5]     = " ";

                // Convert units to metric if --metric was specified
                if (Modes.metric) {
                    altitude = (int) (altitude / 3.2828);
                    speed    = (int) (speed    * 1.852);
                }
        
                if (a->bFlags & MODES_ACFLAGS_SQUAWK_VALID) {
                    snprintf(strSquawk,5,"%04x", a->modeA);}

                if (a->bFlags & MODES_ACFLAGS_SPEED_VALID) {
                    snprintf (strGs, 5,"%3d", speed);}

                if (a->bFlags & MODES_ACFLAGS_HEADING_VALID) {
                    snprintf (strTt, 5,"%03d", a->track);}
        
                if (msgs > 99999) {
                    msgs = 99999;}
        
                if (Modes.interactive_rtl1090) { // RTL1090 display mode

                    if (a->bFlags & MODES_ACFLAGS_ALTITUDE_VALID) {
                        snprintf(strFl,6,"F%03d",(altitude/100));
                    }
                    printf("%06x %-8s %-4s         %-3s %-3s %4s        %-6d  %-2d\n", 
                    a->addr, a->flight, strFl, strGs, strTt, strSquawk, msgs, (int)(now - a->seen));

                } else {                         // Dump1090 display mode
                    char strMode[5]               = "    ";
                    char strLat[8]                = " ";
                    char strLon[9]                = " ";
                    unsigned char * pSig       = a->signalLevel;
                    unsigned int signalAverage = (pSig[0] + pSig[1] + pSig[2] + pSig[3] + 
                                                  pSig[4] + pSig[5] + pSig[6] + pSig[7] + 3) >> 3; 

                    if ((flags & MODEAC_MSG_FLAG) == 0) {
                        strMode[0] = 'S';
                    } else if (flags & MODEAC_MSG_MODEA_ONLY) {
                        strMode[0] = 'A';
                    }
                    if (flags & MODEAC_MSG_MODEA_HIT) {strMode[2] = 'a';}
                    if (flags & MODEAC_MSG_MODEC_HIT) {strMode[3] = 'c';}

                    if (a->bFlags & MODES_ACFLAGS_LATLON_VALID) {
                        snprintf(strLat, 8,"%7.03f", a->lat);
                        snprintf(strLon, 9,"%8.03f", a->lon);
                    }

                    if (a->bFlags & MODES_ACFLAGS_AOG) {
                        snprintf(strFl, 6," grnd");
                    } else if (a->bFlags & MODES_ACFLAGS_ALTITUDE_VALID) {
                        snprintf(strFl, 6, "%5d", altitude);
                    }
 
                    printf("%06x  %-4s  %-4s  %-8s %5s  %3s  %3s  %7s %8s  %3d %5d   %2d\n",
                    a->addr, strMode, strSquawk, a->flight, strFl, strGs, strTt,
                    strLat, strLon, signalAverage, msgs, (int)(now - a->seen));
                }
                count++;
            }
        }
        a = a->next;
    }
}
//


#ifndef _WIN32
// Get the number of rows after the terminal changes size.
int getTermRows() { 
    struct winsize w; 
    ioctl(STDOUT_FILENO, TIOCGWINSZ, &w); 
    return (w.ws_row); 
} 

void sigWinchCallback() {
    signal(SIGWINCH, SIG_IGN);
    Modes.interactive_rows = getTermRows();
    interactiveShowData();
    signal(SIGWINCH, sigWinchCallback); 
}
#else 
int getTermRows() { return MODES_INTERACTIVE_ROWS;}
#endif
//
// =============================== Initialization ===========================
//
void modesInitConfig(void) {
    // Default everything to zero/NULL
    memset(&Modes, 0, sizeof(Modes));

    // Now initialise things that should not be 0/NULL to their defaults
    Modes.gain                    = MODES_MAX_GAIN;
    Modes.freq                    = MODES_DEFAULT_FREQ;
    Modes.check_crc               = 1;
    Modes.net_heartbeat_rate      = MODES_NET_HEARTBEAT_RATE;
    Modes.net_output_sbs_port     = MODES_NET_OUTPUT_SBS_PORT;
    Modes.net_output_raw_port     = MODES_NET_OUTPUT_RAW_PORT;
    Modes.net_input_raw_port      = MODES_NET_INPUT_RAW_PORT;
    Modes.net_output_beast_port   = MODES_NET_OUTPUT_BEAST_PORT;
    Modes.net_input_beast_port    = MODES_NET_INPUT_BEAST_PORT;
    Modes.net_http_port           = MODES_NET_HTTP_PORT;
    Modes.interactive_rows        = getTermRows();
    Modes.interactive_delete_ttl  = MODES_INTERACTIVE_DELETE_TTL;
    Modes.interactive_display_ttl = MODES_INTERACTIVE_DISPLAY_TTL;
    Modes.fUserLat                = MODES_USER_LATITUDE_DFLT;
    Modes.fUserLon                = MODES_USER_LONGITUDE_DFLT;
}
//
//=========================================================================
//
void modesInit(void) {
    int i, q;

//    pthread_mutex_init(&Modes.data_mutex,NULL);
//    pthread_cond_init(&Modes.data_cond,NULL);

    // Allocate the various buffers used by Modes
    if ( ((Modes.icao_cache = (uint32_t *) malloc(sizeof(uint32_t) * MODES_ICAO_CACHE_LEN * 2)                  ) == NULL) ||
         ((Modes.pFileData  = (uint16_t *) malloc(MODES_ASYNC_BUF_SIZE)                                         ) == NULL) ||
         ((Modes.magnitude  = (uint16_t *) malloc(MODES_ASYNC_BUF_SIZE+MODES_PREAMBLE_SIZE+MODES_LONG_MSG_SIZE) ) == NULL) ||
         ((Modes.maglut     = (uint16_t *) malloc(sizeof(uint16_t) * 256 * 256)                                 ) == NULL) ||
         ((Modes.beastOut   = (char     *) malloc(MODES_RAWOUT_BUF_SIZE)                                        ) == NULL) ||
         ((Modes.rawOut     = (char     *) malloc(MODES_RAWOUT_BUF_SIZE)                                        ) == NULL) ) 
    {
        fprintf(stderr, "Out of memory allocating data buffer.\n");
        exit(1);
    }

    // Clear the buffers that have just been allocated, just in-case
    memset(Modes.icao_cache, 0,   sizeof(uint32_t) * MODES_ICAO_CACHE_LEN * 2);
    memset(Modes.pFileData,127,   MODES_ASYNC_BUF_SIZE);
    memset(Modes.magnitude,  0,   MODES_ASYNC_BUF_SIZE+MODES_PREAMBLE_SIZE+MODES_LONG_MSG_SIZE);

    // Validate the users Lat/Lon home location inputs
    if ( (Modes.fUserLat >   90.0)  // Latitude must be -90 to +90
      || (Modes.fUserLat <  -90.0)  // and 
      || (Modes.fUserLon >  360.0)  // Longitude must be -180 to +360
      || (Modes.fUserLon < -180.0) ) {
        Modes.fUserLat = Modes.fUserLon = 0.0;
    } else if (Modes.fUserLon > 180.0) { // If Longitude is +180 to +360, make it -180 to 0
        Modes.fUserLon -= 360.0;
    }
    // If both Lat and Lon are 0.0 then the users location is either invalid/not-set, or (s)he's in the 
    // Atlantic ocean off the west coast of Africa. This is unlikely to be correct. 
    // Set the user LatLon valid flag only if either Lat or Lon are non zero. Note the Greenwich meridian 
    // is at 0.0 Lon,so we must check for either fLat or fLon being non zero not both. 
    // Testing the flag at runtime will be much quicker than ((fLon != 0.0) || (fLat != 0.0))
    Modes.bUserFlags &= ~MODES_USER_LATLON_VALID;
    if ((Modes.fUserLat != 0.0) || (Modes.fUserLon != 0.0)) {
        Modes.bUserFlags |= MODES_USER_LATLON_VALID;
    }

    // Limit the maximum requested raw output size to less than one Ethernet Block 
    if (Modes.net_output_raw_size > (MODES_RAWOUT_BUF_FLUSH))
      {Modes.net_output_raw_size = MODES_RAWOUT_BUF_FLUSH;}
    if (Modes.net_output_raw_rate > (MODES_RAWOUT_BUF_RATE))
      {Modes.net_output_raw_rate = MODES_RAWOUT_BUF_RATE;}

    // Initialise the Block Timers to something half sensible
    ftime(&Modes.stSystemTimeBlk);
    for (i = 0; i < MODES_ASYNC_BUF_NUMBER; i++)
      {Modes.stSystemTimeRTL[i] = Modes.stSystemTimeBlk;}

    // Each I and Q value varies from 0 to 255, which represents a range from -1 to +1. To get from the 
    // unsigned (0-255) range you therefore subtract 127 (or 128 or 127.5) from each I and Q, giving you 
    // a range from -127 to +128 (or -128 to +127, or -127.5 to +127.5)..
    //
    // To decode the AM signal, you need the magnitude of the waveform, which is given by sqrt((I^2)+(Q^2))
    // The most this could be is if I&Q are both 128 (or 127 or 127.5), so you could end up with a magnitude 
    // of 181.019 (or 179.605, or 180.312)
    //
    // However, in reality the magnitude of the signal should never exceed the range -1 to +1, because the 
    // values are I = rCos(w) and Q = rSin(w). Therefore the integer computed magnitude should (can?) never 
    // exceed 128 (or 127, or 127.5 or whatever)
    //
    // If we scale up the results so that they range from 0 to 65535 (16 bits) then we need to multiply 
    // by 511.99, (or 516.02 or 514). antirez's original code multiplies by 360, presumably because he's 
    // assuming the maximim calculated amplitude is 181.019, and (181.019 * 360) = 65166.
    //
    // So lets see if we can improve things by subtracting 127.5, Well in integer arithmatic we can't
    // subtract half, so, we'll double everything up and subtract one, and then compensate for the doubling 
    // in the multiplier at the end.
    //
    // If we do this we can never have I or Q equal to 0 - they can only be as small as +/- 1.
    // This gives us a minimum magnitude of root 2 (0.707), so the dynamic range becomes (1.414-255). This 
    // also affects our scaling value, which is now 65535/(255 - 1.414), or 258.433254
    //
    // The sums then become mag = 258.433254 * (sqrt((I*2-255)^2 + (Q*2-255)^2) - 1.414)
    //                   or mag = (258.433254 * sqrt((I*2-255)^2 + (Q*2-255)^2)) - 365.4798
    //
    // We also need to clip mag just incaes any rogue I/Q values somehow do have a magnitude greater than 255.
    //

    for (i = 0; i <= 255; i++) {
        for (q = 0; q <= 255; q++) {
            int mag, mag_i, mag_q;

            mag_i = (i * 2) - 255;
            mag_q = (q * 2) - 255;

            mag = (int) ((sqrt((mag_i*mag_i)+(mag_q*mag_q)) * 258.433254) - 365.4798);

            Modes.maglut[(i*256)+q] = (uint16_t) ((mag < 65535) ? mag : 65535);
        }
    }

    // Prepare error correction tables
    modesInitErrorInfo();
}




int traficPRD = 0;
int traficPRM = 0;



int StartADSBbin = 0;
int ObnowlenieADSB = 0;
int UrPorog = 50;



DWORD Tidopo; 
int Mwopo=0;
void *ReadSocket8888(void *param);



void SetConnection(int NUM,char *serverhost)
{
 printf("  \n");
 struct sockaddr_in dest_sin;

 cli_socket[NUM] = socket(AF_INET,SOCK_STREAM,0);
 if(cli_socket[NUM] == -1) 
 {
  cli_socket[NUM] = -1;
  strcpy(statusTcpClient[NUM]," ");
  printf("%s\n",statusTcpClient[NUM]);
  statusInt[NUM]=1;
  return ;
 }


 struct hostent * hp;
 unsigned int addr=0;
 
 hp = gethostbyname(serverhost); 
 
 if(!hp)
 { 
  addr = inet_addr((const char *)serverhost); 
 }
 
 if ((!hp)  && (addr == INADDR_NONE)) 
 {
  sprintf(statusTcpClient[NUM]," %s",serverhost);
  printf("%s\n",statusTcpClient[NUM]);
  return;
 } 
 
 if (hp != NULL) memcpy(&(dest_sin.sin_addr.s_addr),hp->h_addr,hp->h_length); 
 else            dest_sin.sin_addr.s_addr = addr; 
 
 if (hp)  dest_sin.sin_family = hp->h_addrtype; 
 else     dest_sin.sin_family = AF_INET; 
 
 dest_sin.sin_port = htons(CLI_PORT[NUM]);




 if(connect(cli_socket[NUM],(const struct sockaddr *)&dest_sin,sizeof(dest_sin)) < 0)
 {
  close(cli_socket[NUM]);
  cli_socket[NUM] = -1;
  strcpy(statusTcpClient[NUM]," connect");
  printf("%s\n",statusTcpClient[NUM]);
  return ;
 }




 strcpy(statusTcpClient[NUM]," ");
 strcat(statusTcpClient[NUM],inet_ntoa((struct in_addr)dest_sin.sin_addr));

  printf("%s\n",statusTcpClient[NUM]);

  
 ObnowlenieADSB = 0;


 if(NUM == 2)
 {
  char str[256];
  sprintf(str,"#%s\r\n",NamePrmADSB);
  SendInfaOutTcp(cli_socket[NUM],str,strlen(str));
  sprintf(str,"#%.6f\r\n",LOC_B2/3600.0);
  SendInfaOutTcp(cli_socket[NUM],str,strlen(str));
  sprintf(str,"#%.6f\r\n",LOC_L2/3600);
  SendInfaOutTcp(cli_socket[NUM],str,strlen(str));
  if(BinarComOn) sprintf(str,"#BINARY");
  else           sprintf(str,"#TEXT");
  if(CompressOn) strcat(str,":COMPRESS");
  strcat(str,"\r\n");
  SendInfaOutTcp(cli_socket[NUM],str,strlen(str));
 }


 statusInt[NUM]=9;


}


void ClientStop(int NUM)
{
 //if(statusInt[NUM] != 9) return;

 if(cli_socket[NUM] != -1)
 {
  shutdown(cli_socket[NUM],2);
  close(cli_socket[NUM]);
  cli_socket[NUM] = -1;
  strcpy(statusTcpClient[NUM]," ");
  printf("%s\n",statusTcpClient[NUM]);
  statusInt[NUM]=10;
  return ;
 }
}



int prdCodogramm101(int cat,unsigned char *FspecRecord, int *lenn)
{
 int len = *lenn;
 unsigned char  prd[0xFFFF];
 int   i,n=2;

 
 traficPRD = traficPRD + *lenn;
 
 
 prd[0] = 16;  // 
 prd[1] = 2;   // 
 if(cat == 16) //  
 {
  prd[n] = 16;
  n++;
  prd[n] = 16;
  n++;
 }
 else // 
 {
  prd[n] = (unsigned char)cat;
  n++;
 }

 len = len + 3 + 1;//
 prd[n] = (len & 0xFF00) >> 8;
 prd[n+1] = len & 0xFF;

 if(prd[n] == 16 || prd[n+1] == 16)// 
 {
  unsigned char b = prd[n+1];
  if(prd[n] == 16)
  {
   n++;
   prd[n] = 16;
   n++;
  }
  else
  {
   n++;
  }
  if(b == 16)
  {
   prd[n] = 16;
   n++;
   prd[n] = 16;
   n++;
  }
  else
  {
   prd[n] = b;
   n++;
  }
 }
 else // 
 {
  n = n + 2;
 }

 
 prd[n] = 0;
 n++;

 for(i = 0; i < len-3-1; i++)
 {
  if(FspecRecord[i] == 16)
  {
   prd[n] = 16;
   n++;
   prd[n] = 16;
   n++;
  }
  else
  {
   prd[n] = FspecRecord[i];
   n++;
  }
 }

 prd[n] = 16;
 n++;
 prd[n] = 3;
 n++;

 memcpy(FspecRecord,prd,n);
 *lenn = n;

 return 1;
}





//*
int SendInfaOutTcpCOMPRESS(int sid,char *prm, int LEN)
{
 int ll = 0,len = LEN;
 int r = 0;
 char *PRMDb = prm;



 if(CompressOn)
 {
  if(ukCompress + LEN < 0xFFFF)
  {
   memcpy(&bufCompress[ukCompress],prm,LEN);
   ukCompress = ukCompress + LEN;
  }
  else
  {
   int err;    
   destLen = 0xFFFF;
   err = compress(dest,&destLen,(unsigned char *)bufCompress,ukCompress);
   if(err == 0)
   {
    char str[256];
	sprintf(str,"%d -> %d",ukCompress,destLen);
    printf("%s\n",str);
	int lenn = destLen;
    prdCodogramm101(101,dest, &lenn);
	PRMDb = (char *)dest;
    len = lenn;
   }
   else     printf("Error Compress\n");
   //   
   ukCompress     = 0;
   TicSecCompress = 0;
   memcpy(&bufCompress[ukCompress],prm,LEN);
   ukCompress = ukCompress + LEN;
   printf("Compress\n");
  }
  if(TicSecCompress > KogDa)
  {

   int err;    
   destLen = 0xFFFF;
   err = compress(dest,&destLen,(unsigned char *)bufCompress,ukCompress);
   if(err == 0)
   {
    char str[256];
	int lenn = destLen;
    prdCodogramm101(101,dest, &lenn);
	PRMDb = (char *)dest;
    len = lenn;
	sprintf(str,"%d -> %d",ukCompress,len);
    printf("%s\n",str);
   }
   else printf("Error Compress\n");
   //   
   ukCompress     = 0;
   TicSecCompress = 0;
   //return 0; ///////////////////////////////
  }
  else
  {
   return 0;
  }
 }

 traficPRD = traficPRD + len;


 do
 {
  r = send(sid,(const char FAR *)PRMDb,len,0);
  if(r != -1 && r != len)
  {
   PRMDb = &PRMDb[r];
   len = len - r;
   r = -1;
  }
  if(r != -1) break;
  ll++; if(ll > 15) break;
  usleep(300000);
 }
 while(sid != -1 && r == -1);

 return ll;
}




int SendInfaOutTcp(int sid,char *prm, int LEN)
{
 int ll = 0,len = LEN;
 int r = 0;
 char *PRMDb = prm;


 traficPRD = traficPRD + LEN;



 do
 {
  r = send(sid,(const char FAR *)PRMDb,len,0);
  if(r != -1 && r != len)
  {
   PRMDb = &PRMDb[r];
   len = len - r;
   r = -1;
  }
  if(r != -1) break;
  ll++; if(ll > 15) break;
  usleep(300000);
 }
 while(sid != -1 && r == -1);

 return ll;
}






void PrmDannTCP(char *buf, int n)
{
 printf("PRM - %d\n",n);

}





void WndProc_OnWSANetEventClient(int NUM)
{
 char szTemp[1000];
 int rc;
 memset(szTemp,0,sizeof(szTemp));
 rc=recv(cli_socket[NUM],szTemp,sizeof(szTemp),0);

 traficPRM = traficPRM + rc;

 if(rc && rc != -1)
 {
  PrmDannTCP(szTemp,rc);
 }
 else 
 {
  ClientStop(NUM);
 }
 
}



void *ReadSocket8888(void *pr)
{
 int Zaciklivanie = 0;
 while(CIKL)
 {
  if(statusInt[ServerRadio]!=9) 
  {
   Zaciklivanie++;
   if(Zaciklivanie > 20) usleep(100000);
   SetConnection(ServerRadio,addr_IP[ServerRadio]);
   usleep(300000);
   if(statusInt[ServerRadio]==9) 
   {

   }
  }
  else
  {
   WndProc_OnWSANetEventClient(ServerRadio);
   Zaciklivanie = 0;
  }
 }
 Mwopo=10;
 return pr;
}



int KL_W(int k)
{
 static int klbuf[10];
 static int kl_uk=0;

 if(k==27 && kl_uk==1) {kl_uk=0;return 6000;}
 if(k==27) {klbuf[0]=k;kl_uk=1;return 0;}
 if(k==91 && kl_uk==1) {klbuf[1]=k;kl_uk=2;return 0;}

 if(kl_uk==2 && k==65) {kl_uk=0;return 5001;}// up  
 if(kl_uk==2 && k==66) {kl_uk=0;return 5002;}// down  
 if(kl_uk==2 && k==67) {kl_uk=0;return 5003;}// regh  
 if(kl_uk==2 && k==68) {kl_uk=0;return 5004;}// left  
 if(kl_uk==2 && k==71) {kl_uk=0;return 5005;}// centr  

 if(kl_uk==2 && (k==49 || k==50 || k==51 || k==52 || k==53 || k==54 || k==91)) {klbuf[2]=k;kl_uk++;return 0;}

 if(kl_uk==3 && k==126 && klbuf[2]==50) {kl_uk=0;return 5006;}// insert  
 if(kl_uk==3 && k==126 && klbuf[2]==49) {kl_uk=0;return 5007;}// home  
 if(kl_uk==3 && k==126 && klbuf[2]==51) {kl_uk=0;return 5008;}// delete  
 if(kl_uk==3 && k==126 && klbuf[2]==52) {kl_uk=0;return 5009;}// end  
 if(kl_uk==3 && k==126 && klbuf[2]==53) {kl_uk=0;return 5010;}// page up  
 if(kl_uk==3 && k==126 && klbuf[2]==54) {kl_uk=0;return 5011;}// page down  


 if(kl_uk==3 && klbuf[2]==91 && k==65) {kl_uk=0;return 5012;}// F1  
 if(kl_uk==3 && klbuf[2]==91 && k==66) {kl_uk=0;return 5013;}// F2  
 if(kl_uk==3 && klbuf[2]==91 && k==67) {kl_uk=0;return 5014;}// F3  
 if(kl_uk==3 && klbuf[2]==91 && k==68) {kl_uk=0;return 5015;}// F4  
 if(kl_uk==3 && klbuf[2]==91 && k==69) {kl_uk=0;return 5016;}// F5  


 if((klbuf[2]==49 || klbuf[2]==50) && kl_uk==3) {klbuf[3]=k;kl_uk++;return 0;}

 if(kl_uk==4 && k==126 && klbuf[3]==55) {kl_uk=0;return 5017;}// F6  
 if(kl_uk==4 && k==126 && klbuf[3]==56) {kl_uk=0;return 5018;}// F7  
 if(kl_uk==4 && k==126 && klbuf[3]==57) {kl_uk=0;return 5019;}// F8  
 if(kl_uk==4 && k==126 && klbuf[3]==48) {kl_uk=0;return 5020;}// F9  
 if(kl_uk==4 && k==126 && klbuf[3]==49) {kl_uk=0;return 5021;}// F10  
 if(kl_uk==4 && k==126 && klbuf[3]==51) {kl_uk=0;return 5022;}// F11  
 if(kl_uk==4 && k==126 && klbuf[3]==52) {kl_uk=0;return 5023;}// F12  

 kl_uk=0;
 return k;

}





int main(int argc, char* argv[])
{ 
 struct termios oldtio,newtio;
 int kl,klfull;


 modesInitConfig(); 
 modesInit();




 tcgetattr(0,&oldtio); 
 memcpy(&newtio,&oldtio,sizeof(newtio));
 newtio.c_lflag = newtio.c_lflag & ~(0x00000002 + 0x00000008);
 tcsetattr(0,TCSANOW,&newtio);

 pthread_mutex_init(&hSemaFILE,0);

 printf(" \n");

 pthread_t    tid8888;
 if(pthread_create(&tid8888,NULL,ReadSocket8888,(void *)NULL)== -1) perror("pthread_create ReadSocket8888\n");

 pthread_t    tidadsb;
 if(pthread_create(&tidadsb,NULL,adsb_f,(void *)NULL)== -1) perror("pthread_create adsb_f\n");


 while(CIKL)
 {
  kl=getchar();
  klfull=KL_W(kl);
  if(klfull==6000) break;



  if(klfull && klfull<5000) 
  {

   if(klfull == 32)
   {
    if(PrintVisual < 2) PrintVisual++;
    else                PrintVisual = 0;
   }


  }
 }




 tcsetattr(0,TCSANOW,&oldtio);
 



 pthread_mutex_destroy(&hSemaFILE);


 printf(" \n");


 CIKL = 0;

 return 0;
}





unsigned char *buffer;
unsigned int *mag_buf;
static rtlsdr_dev_t *dev = NULL; 
#define MODES_PREAMBLE_LEN 16
#define MODES_LONG_LEN 112
#define ADSB_FREQ 1090000000
#define ADSB_RATE 2000000 
  
unsigned int mag_table[256][256]; 

struct msgbuf {
	long mtype;
	char mtext[128];
};
 

void prepare_mag_buf(unsigned char *iq_buf, unsigned int iq_buf_len,unsigned int *mag_buf) 
{
 int k = 0;

 while (k < (int)iq_buf_len) 
 {
  mag_buf[k / 2] = mag_table[iq_buf[k]][iq_buf[k + 1]];
  k = k + 2;
 }
} 


void printTime(char *d)
{
 static uint64_t sGllt;
 static uint64_t eGllt;
 static uint64_t sGlt;
 static uint64_t eGlt;
 static uint64_t lt;
 unsigned long hlt;
 unsigned long llt;



 if(d[0]!='@' || !OnVievTimeCorrect)
 {
  switch (PrintVisual)       
  {
   case 1:
    printf("%d                           \r",traficPRD);
   break;       
   
   case 2:
    printf("%s",d);
   break;       
   
  }
  return;
 }


 char st[13];
 st[0]=d[1];
 st[1]=d[2];
 st[2]=d[3];
 st[3]=d[4];
 st[4]=0;
 sscanf(st, "%08x", &hlt);
 st[0]=d[5];
 st[1]=d[6];
 st[2]=d[7];
 st[3]=d[8];
 st[4]=d[9];
 st[5]=d[10];
 st[6]=d[11];
 st[7]=d[12];
 st[8]=0;
 sscanf(st, "%08x", &llt);
// lt = (hlt << 32) + llt;
 lt = (uint64_t)((hlt * 0x100000000) + llt);




 if(sssStartTimer == 0)
 {
  sGlt  = time(NULL);//GetTickCount();
  sGllt = lt;
  sssStartTimer = 1;
 }
 static int cikl = 0;
 static int dlina = 0;
 cikl++;
 dlina = dlina + (((strlen(&d[13]) - 1)/2));
 eGllt = lt;
 eGlt  = time(NULL);//GetTickCount();//time(NULL);
 //if(eGlt - sGlt >= 60000)
 {
  long double sek = (long double)(eGlt - sGlt);
  long double usb = (long double)((eGllt - sGllt)/GlobDel);
  char str[256];
  if(usb >= 3600)
  {
   long ch  = (long)usb;
   long min = (long)(ch % 3600);
   ch       = ch/3600;
   long sk = min % 60;
   min = min / 60;

   long Sch  = (long)sek;
   long Smin = (long)(Sch % 3600);
   Sch       = Sch/3600;
   long Ssk = Smin % 60;
   Smin = Smin / 60;
   
   sprintf(str," = %d:%02d:%02d   = %d:%02d:%02d     %s",ch,min,sk,Sch,Smin,Ssk,d);
  }
  else
  {
   if(usb >= 60)
   {
    long min = (long)usb;
    long sk  = min % 60;
	min      = min / 60;

    long Smin = (long)sek;
    long Ssk  = Smin % 60;
	Smin      = Smin / 60;
    sprintf(str," = %02d:%02d   = %02d:%02d     %s",min,sk,Smin,Ssk,d);
   }
   else
   {
    sprintf(str," = %.0f   = %.0f     %s",usb,sek,d);
   }
  }



  printf("%s",str);
  cikl = 0;
  dlina = 0;
 }


}


int Bi = 0,Ci = 0;

void GdemADSB(char *szTemp, int rc)
{
 int i;
 static char d[1024]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
 static int l = 0; 
 static char st[2]={0,0};



 if(BinarComOn)
 {
  int rez = -1;
  for(i = 0; i < rc; i++)
  {

   st[0] = st[1];
   st[1] = szTemp[i];

   if(st[0] == 0x1A && st[1] == 0x1A)
   {
    st[1] = 0;
	i++;
	if(i >= rc) break;
   }


   if(st[0] == 0x1A && (st[1] == 0x31 || st[1] == 0x32 || st[1] == 0x33)) 
   {
    d[0] = st[0];
    d[1] = st[1];
	l = 2;
   }
   else
   {

    d[l] = szTemp[i];
    if(l < 1023) l++;



   if(l == 11 && d[0] == 0x1A && d[1] == 0x31)
   {
    char str[128];
    sprintf(str,"@%02X%02X%02X%02X%02X%02X%02X%02X;\r\n",d[2] & 0xFF,d[3] & 0xFF,d[4] & 0xFF,d[5] & 0xFF,d[6] & 0xFF,d[7] & 0xFF,d[9] & 0xFF,d[10] & 0xFF);
    
    if((unsigned)UrPorog <= (unsigned)(d[8] & 0xFF))
	{
         pthread_mutex_lock(&hSemaFILE);
	 if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
         pthread_mutex_unlock(&hSemaFILE);
	}
    printTime(str);

    ObnowlenieADSB = 0;
    l = 0;
    memset(d,0,sizeof(d));
   }
   if(l == 16 && d[0] == 0x1A && d[1] == 0x32)
   {
    char str[128];
    sprintf(str,"@%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;\r\n",d[2] & 0xFF,d[3] & 0xFF,d[4] & 0xFF,d[5] & 0xFF,d[6] & 0xFF,d[7] & 0xFF,d[9] & 0xFF,d[10] & 0xFF,d[11] & 0xFF,d[12] & 0xFF,d[13] & 0xFF,d[14] & 0xFF,d[15] & 0xFF);
  
    if((unsigned)UrPorog <= (unsigned)(d[8] & 0xFF))
	{
         pthread_mutex_lock(&hSemaFILE);
	 if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
         pthread_mutex_unlock(&hSemaFILE);
	}
	
    printTime(str);

    ObnowlenieADSB = 0;
    l = 0;
    memset(d,0,sizeof(d));
   }
   if(l == 23 && d[0] == 0x1A && d[1] == 0x33)
   {
    char str[128];
    sprintf(str,"@%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;\r\n",d[2] & 0xFF,d[3] & 0xFF,d[4] & 0xFF,d[5] & 0xFF,d[6] & 0xFF,d[7] & 0xFF,d[9] & 0xFF,d[10] & 0xFF,d[11] & 0xFF,d[12] & 0xFF,d[13] & 0xFF,d[14] & 0xFF,d[15] & 0xFF,d[16] & 0xFF,d[17] & 0xFF,d[18] & 0xFF,d[19] & 0xFF,d[20] & 0xFF,d[21] & 0xFF,d[22] & 0xFF);

    if((unsigned)UrPorog <= (unsigned)(d[8] & 0xFF))
	{
         pthread_mutex_lock(&hSemaFILE);
	 if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
         pthread_mutex_unlock(&hSemaFILE);
	}
    printTime(str);
    l = 0;
    memset(d,0,sizeof(d));
   }

   }
  }



  return;
 }



 //_printf("%d\n",rc);
 for(i = 0; i < rc; i++)
 {
  d[l] = szTemp[i];
  if(d[l] == 13 || d[l] == 10)
  {
   d[l] = 0;
   if(d[0])
   {
    int rez = -1;

    if(d[0]=='*')
	{
         char str[128];
         sprintf(str,"%s\r\n",d);
         pthread_mutex_lock(&hSemaFILE);
	 if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
         pthread_mutex_unlock(&hSemaFILE);
         printTime(str);
         ObnowlenieADSB = 0;
	}

    if(d[0]=='@')
	{
         char str[128];
         sprintf(str,"%s\r\n",d);
         pthread_mutex_lock(&hSemaFILE);
	 if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
         pthread_mutex_unlock(&hSemaFILE);
         printTime(str);
         ObnowlenieADSB = 0;
	}

    if(d[0]=='M' && d[1]=='S' && d[2]=='G')
    {
     char str[128];
     sprintf(str,"%s\r\n",d);
     pthread_mutex_lock(&hSemaFILE);
     if(statusInt[2]==9 && !OutOriginalDateOn) SendInfaOutTcpCOMPRESS(cli_socket[2],str,strlen(str));//send(cli_socket[2],(const char FAR *)str,strlen(str),0);
     pthread_mutex_unlock(&hSemaFILE);
     printTime(str);
     ObnowlenieADSB = 0;
    }

   }
   
   l = 0;
   memset(d,0,sizeof(d));
  }
  else
  {
   l++;
   if(l >=1023)
   {
    l = 0;
    memset(d,0,sizeof(d));
   }
  }
 }
}






 

void prepare_mag_table() 
{
 int i, q;
 for (i = 0; i < 255; i++)
	for (q = 0; q < 255; q++)
			mag_table[i][q] = (int)sqrt((i - 127) * (i - 127) + (q - 127) * (q - 127));
//			mag_table[i][q] = (int)/*sqrt*/((i - 127) * (i - 127) + (q - 127) * (q - 127));
}




FILE *outTest = NULL;




//
//=========================================================================
//
// When a new message is available, because it was decoded from the RTL device, 
// file, or received in the TCP input port, or any other way we can receive a 
// decoded message, we call this function in order to use the message.
//
// Basically this function passes a raw message to the upper layers for further
// processing and visualization
//
void useModesMessage(struct modesMessage *mm,uint32_t j) {
    if ((Modes.check_crc == 0) || (mm->crcok) || (mm->correctedbits)) { // not checking, ok or fixed

    unsigned char t[10]={0,0,0,0,0,0,0,0};
      unsigned char TR = TimeRtl & 0xFF; 
      uint32_t tt = j;
      //uint64_t tt = TimeRtl + j;
   static char outstr[256];

//    struct aircraft *a = Modes.aircrafts;

//printf("%05X  %02X%02X%02X%02X%02X%02X   ",j,t[5] & 0xFF,t[4] & 0xFF,t[3] & 0xFF,t[2] & 0xFF,t[1] & 0xFF,t[0] & 0xFF);

        // Always track aircraft
	if(mm->msgbits == 56) 
	{
    //     if(j < 240)
//	 {
//          if(outTest != NULL) fprintf(outTest,"Error tt = tt - 240 %d   %d\n",mm->msgbits,j);
//          return;
//	 }
//         tt = tt - 240;
      memcpy(t,(void *)&tt,4);
      t[5] = TR;
//         memcpy(t,(void *)&tt,4);
//         t[5] = TR;
         //memcpy(t,(void *)&j,4);
         sprintf(outstr,"@%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;\r\n",t[5] & 0xFF,t[4] & 0xFF,t[3] & 0xFF,t[2] & 0xFF,t[1] & 0xFF,t[0] & 0xFF,mm->msg[0],mm->msg[1],mm->msg[2],mm->msg[3],mm->msg[4],mm->msg[5],mm->msg[6]);
//         if(outTest != NULL) 
//         {
//          fprintf(outTest,"@%02X%02X%02X%02X%02X%02X %02X%02X%02X%02X%02X%02X%02X;\n",t[5] & 0xFF,t[4] & 0xFF,t[3] & 0xFF,t[2] & 0xFF,t[1] & 0xFF,t[0] & 0xFF,mm->msg[0],mm->msg[1],mm->msg[2],mm->msg[3],mm->msg[4],mm->msg[5],mm->msg[6]);
///          displayModesMessage(mm);
//         }
		}
	if(mm->msgbits == 112) 
        //else
		{
//         if(j < 480)
//	 {
//          if(outTest != NULL) fprintf(outTest,"Error tt = tt - 480 %d   %d\n",mm->msgbits,j);
//          return;
//	 }
//         tt = tt - 480;
      memcpy(t,(void *)&tt,4);
      t[5] = TR;
//         memcpy(t,(void *)&tt,4);
//         t[5] = TR;
//         //memcpy(t,(void *)&j,4);
         sprintf(outstr,"@%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;\r\n",t[5] & 0xFF,t[4] & 0xFF,t[3] & 0xFF,t[2] & 0xFF,t[1] & 0xFF,t[0] & 0xFF,mm->msg[0],mm->msg[1],mm->msg[2],mm->msg[3],mm->msg[4],mm->msg[5],mm->msg[6],mm->msg[7],mm->msg[8],mm->msg[9],mm->msg[10],mm->msg[11],mm->msg[12],mm->msg[13]);
//         if(outTest != NULL) 
//         {
//          fprintf(outTest,"@%02X%02X%02X%02X%02X%02X %02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;\n",t[5] & 0xFF,t[4] & 0xFF,t[3] & 0xFF,t[2] & 0xFF,t[1] & 0xFF,t[0] & 0xFF,mm->msg[0],mm->msg[1],mm->msg[2],mm->msg[3],mm->msg[4],mm->msg[5],mm->msg[6],mm->msg[7],mm->msg[8],mm->msg[9],mm->msg[10],mm->msg[11],mm->msg[12],mm->msg[13]);
////          displayModesMessage(mm);
    //     }
		}


   GdemADSB(outstr, strlen(outstr));
//   if(ServerTCP) 
//   {
//    for(int i = 0; i < KOL_CONNECT; i++)
//	{
//	 if(srv_strIP[i][0])
//	 {
//      int ll = SendInfaOutTcp(srv_socket[i],outstr,strlen(outstr));
//      if(ll > 15) 		  
//	  { 
//	  }
//	 }
//	}
//
//   }
        Modes.net_heartbeat_count = 0;
    }
}


char NameFileArh[256]={""};

DWORD Tidopo2; 
int Mwopo2=0;
void *Myopo2(void *pr)
{

 while(!Mwopo2)
 {
  if(CIKL == 0) break;
  while(ukSave != ukLoad)
  {
   //struct tm *tb;
   //char str[256];
   //time_t tGl=time(NULL);
   //tb = localtime(&tGl);
   //if(tb->tm_hour != 0)
   //{
//    sprintf( str, "/opt/adsbcli_new/%02d%02d%02d_%02d",tb->tm_year-100,tb->tm_mon+1,tb->tm_mday,tb->tm_hour);
//    if(strcmp(NameFileArh,str))
//    {
//     if(outTest != NULL) fclose(outTest);
//     strcpy(NameFileArh,str);
//     outTest = fopen(NameFileArh,"at");
//    }
  // }
  // if(CIKL == 0) 
  // {
//    break;
//    if(outTest != NULL) 
//    {
//     fclose(outTest);
//     outTest = NULL;
//    }
  // }

  computeMagnitudeVector((unsigned short *)RAW_SDR[ukLoad]);
  detectModeS(Modes.magnitude, MODES_ASYNC_BUF_SAMPLES);
  //TimeRtl = TimeRtl + MODES_ASYNC_BUF_SAMPLES;
  TimeRtl = TimeRtl + 1;


   if(ukLoad < 99) ukLoad++;
   else            ukLoad = 0;
  }


  usleep(10000);
 }
 Mwopo=10;
 return pr;
}







void *adsb_f(void *pr)
{
 char str[1024];
 int device_count;
 unsigned int dev_index = 1;
 int gain = 2000000;
 char vendor[256], product[256], serial[256];
 int i, r, n_read;

 
 prepare_mag_table();

 buffer = (unsigned char *)malloc(DEFAULT_BUF_LENGTH * sizeof(unsigned char));
 mag_buf = (unsigned int *)malloc(DEFAULT_BUF_LENGTH * sizeof(unsigned int));

 device_count = rtlsdr_get_device_count();
 if (!device_count) 
 {
  printf("%s\n","   ");
  goto exit2;
 }
 sprintf(str," %d  : ", device_count);
 printf("%s\n",str);
 printf("%s\n","1");
 for (i = 0; i < device_count; i++) 
 {
  printf("%s\n","2");
  rtlsdr_get_device_usb_strings(i, vendor, product, serial);
  sprintf(str,"\t%d: %s, %s, SN: %s ", i, vendor, product, serial);
  printf("%s\n",str);
 }
 printf("%s\n","3");
 dev_index = 0;
 sprintf(str," %d: %s", dev_index,rtlsdr_get_device_name(dev_index));
 printf("%s\n",str);

 r = rtlsdr_open(&dev, dev_index);
 if (r < 0) 
 {
  sprintf(str,"   #%d", dev_index);
  printf("%s\n",str);
  goto exit2;
 }

 r = rtlsdr_set_tuner_gain_mode(dev, 1); // 0 - autogain
 if (r != 0) printf("%s\n","  tuner gain mode");

 int ngains;
 int gains[100];

 ngains = rtlsdr_get_tuner_gains(dev, gains);
 printf("%s\n"," gains:");
 for (i = 0; i < ngains; i++)
 {
  char sss[256];
  sprintf(sss," %.2f", gains[i] / 10.0);
  strcat(str,sss);
 }
 //_printf("");

 if (gain == -1) 
 {
  gain = gains[ngains - 1];
  rtlsdr_set_tuner_gain(dev, gain);
  sprintf(str,"  gain %.2f", (float)rtlsdr_get_tuner_gain(dev)/10);
  printf("%s\n",str);
 }
 else if (gain == -2) 
 {
  rtlsdr_set_tuner_gain_mode(dev, 0);
  sprintf(str," autogain.");
  printf("%s\n",str);
 }
 else 
 {
  gain = 2000000 * 10;
  rtlsdr_set_tuner_gain(dev, gain);
  sprintf(str," gain to %.2f", (float)rtlsdr_get_tuner_gain(dev)/10);
  printf("%s\n",str);
 }


 r = rtlsdr_set_testmode(dev, 1);
 if (r < 0) 
 {
  sprintf(str," rtlsdr_set_testmode");
  printf("%s\n",str);
  //goto exit;
 } 
 else
 {
  sprintf(str,"rtlsdr_set_testmode");
  printf("%s\n",str);
 }


 r = rtlsdr_set_agc_mode(dev, 1);

 /* Tune to freq. */
 r = rtlsdr_set_center_freq(dev, ADSB_FREQ);
 if (r < 0) 
 {
  sprintf(str,"  center freq. %u", ADSB_FREQ);
  printf("%s\n",str);
  goto exit;
 } 
 else
 {
  sprintf(str," %u", ADSB_FREQ);
  printf("%s\n",str);
 }

 /* Sample rate */
 r = rtlsdr_set_sample_rate(dev, ADSB_RATE);
 if (r < 0) 
 {
  sprintf(str,"Failed to sample rate %u", ADSB_RATE);
  printf("%s\n",str);
  goto exit;
 }

 r = rtlsdr_reset_buffer(dev);
 if (r < 0) 
 {
  sprintf(str,"Failed to reset buffer.");
  printf("%s\n",str);
 }
 rtlsdr_read_sync(dev, NULL, 4096, NULL);

 pthread_t    tid8888;
 if(pthread_create(&tid8888,NULL,Myopo2,(void *)NULL)== -1) perror("pthread_create adsb_f\n");


 while (CIKL) 


 {//n_read = DEFAULT_BUF_LENGTH;
  r = rtlsdr_read_sync(dev, buffer, DEFAULT_BUF_LENGTH, &n_read);
  // TODO async read
  if (r < 0) 
  {
   //_printf("sync_read failed.");
  }
  n_read = DEFAULT_BUF_LENGTH;

  memcpy(RAW_SDR[ukSave],buffer,n_read);
  RAW_SDRcnt[ukSave] = n_read;
  if(ukSave < 99) ukSave++;
  else            ukSave = 0;
 }


 exit:
 rtlsdr_close(dev);
 exit2:
 free(buffer);
 free(mag_buf);

 return pr;
} 
